//-*-c++-*------------------------------------------------------------
//
// File name : bioLogWindow.cc
// Author :    Michel Bierlaire
// Date :      Mon Apr  4 17:49:58 2016
//
//--------------------------------------------------------------------

#include "bioLogWindow.h"
#include "patDisplay.h"
#include "patVersion.h"
#include <pangomm/fontdescription.h>
#include <gtkmm/main.h>

bioLogWindow::bioLogWindow() {
  
  stringstream str ;
  // str << patVersion::the()->getVersionInfo() << ": log messages" ;
  // set_title(str.str()) ;
  // set_default_size(600,400) ;

  set_min_content_width(600) ;
  set_min_content_height(400) ;
  theBuffer = Gtk::TextBuffer::create() ;

  theLog.set_buffer(theBuffer) ;
  
  Pango::FontDescription font_desc = Pango::FontDescription("monospace") ;
  theLog.override_font(font_desc) ;
  add(theLog) ;
  set_policy(Gtk::POLICY_AUTOMATIC,Gtk::POLICY_AUTOMATIC) ;
  //  set_hexpand(TRUE) ;
}

void bioLogWindow::initLog() {
  patDisplay::the().setLogMessage(this) ;
}


bioLogWindow::~bioLogWindow() {

}

void bioLogWindow::addLogMessage(patString m) {
  Gtk::TextBuffer::iterator endIter = theBuffer->end() ; 
  theBuffer->insert(endIter,Glib::ustring(m)) ;
  endIter = theBuffer->end() ; 
  theBuffer->insert(endIter,Glib::ustring("\n")) ;
  endIter = theBuffer->end() ; 
  theLog.scroll_to(endIter) ;

  // The following loop is necessary to allow the display to be
  // updated as the program is running

  while (Gtk::Main::events_pending ()) {
    Gtk::Main::iteration();
  }
}
